'REGISTERS
DIM INTEGER AREG, XREG, YREG, STKP, PC, STAT
'FLAGS
DIM INTEGER CFLG = 1
DIM INTEGER ZFLG = 1 << 1
DIM INTEGER IFLG = 1 << 2
DIM INTEGER DFLG = 1 << 3
DIM INTEGER BFLG = 1 << 4
DIM INTEGER UFLG = 1 << 5
DIM INTEGER VFLG = 1 << 6
DIM INTEGER NFLG = 1 << 7
'INTERNAL HELPERS
DIM INTEGER ADDR, FETD, TEMP, AABS, AREL, OP, CYCS
DIM INTEGER CLKC, HI, LO, BOOL, LGPC, ROLY, AC1, AC2

'TEMP VARIABLES UNTIL CODE OPTIMIZATION
DIM STRING OPNM$ = ""

FUNCTION GETFLG(FLG)
GETFLG = ((STAT AND FLG) > 0)
END FUNCTION

SUB SETFLG(FLG, BOOL)
IF BOOL THEN : STAT = (STAT OR FLG) AND &HFF
ELSE : STAT = (STAT AND INV FLG) AND &HFF
ENDIF
END SUB

SUB CPUW(ADDR, CARTDATA)
BUSW(ADDR AND &HFFFF, CARTDATA AND &HFF)
END SUB

SUB CPURESET()
AABS = &HFFFC
LO = BUSR(AABS) AND &HFF
HI = BUSR(AABS + 1) AND &HFF
PC = (HI << 8) OR LO
AREG = 0
XREG = 0
YREG = 0
STKP = &HFD
STAT = &H00 OR UFLG
AREL = &H0000
AABS = &H0000
FETD = &H00
CYCS = CYCS + 7
END SUB

SUB IRQCPU()
IF GETFLG(IFLG) = 0 THEN
CPUW((&H0100 + STKP), ((PC >> 8) AND &H00FF))
STKP = (STKP - 1) AND &HFF
CPUW((&H0100 + STKP), (PC AND &H00FF))
STKP = (STKP - 1) AND &HFF

SETFLG(BFLG, 0)
SETFLG(UFLG, 1)
SETFLG(IFLG, 1)

CPUW((&H0100 + STKP), STAT)
STKP = (STKP - 1) AND &HFF
AABS = &HFFFE
LO = BUSR(AABS)
HI = BUSR(AABS + 1)
PC = ((HI << 8) OR LO)
CYCS = CYCS + 7
END IF
END SUB

SUB NMICPU()
CPUW((&H0100 + STKP), ((PC >> 8) AND &H00FF))
STKP = (STKP - 1) AND &HFF
CPUW(&H0100 + STKP, PC AND &H00FF)
STKP = (STKP - 1) AND &HFF

SETFLG(BFLG, 0)
SETFLG(UFLG, 1)
SETFLG(IFLG, 1)

CPUW((&H0100 + STKP), STAT)
STKP = (STKP - 1) AND &HFF
AABS = &HFFFA
LO = BUSR(AABS)
HI = BUSR(AABS + 1)
PC = ((HI << 8) OR LO)
CYCS = CYCS + 8
END SUB

SUB CPUCLOCK()
IF CYCS = 0 THEN 
OP = (BUSR(PC)) AND &HFF 
LGPC = PC 
SETFLG(UFLG, 1) 
PC = (PC + 1) AND &HFFFF
IF DEBUG THEN : PRINTDEBUG() : END IF
LOOKUPADDR(OP) 
CYCS = CYCS + (AC1 AND AC2) : AC1 = 0 : AC2 = 0 
SETFLG(UFLG,1)
END IF
CLKC = CLKC + 1 : CYCS = CYCS - 1
END SUB

SUB PRINTDEBUG
? HEX$(LGPC) ; " " ; OPNM ; " A:" ; HEX$(AREG, 2) ; " X:" ; HEX$(XREG, 2) ; " Y:" ; HEX$(YREG, 2) ; " P:" ; HEX$(STAT, 2) ; " SP:" ; HEX$(STKP, 2) ; " CYC:" ; CLKC ; " SL:" SLIN ; " PCYC:" PCYC

END SUB

SUB LOOKUPADDR(OP)
SELECT CASE OP
CASE &H00 : CYCS = CYCS + 7 : OPNM = "BRK {IMP}" : CIMP() : CBRK()
CASE &H01 : CYCS = CYCS + 6 : OPNM = "ORA {IZX}" : CIZX() : CORA() 
CASE &H02 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H03 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H04 : CYCS = CYCS + 3 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H05 : CYCS = CYCS + 3 : OPNM = "ORA {ZP0}" : CZP0() : CORA() 
CASE &H06 : CYCS = CYCS + 5 : OPNM = "ASL {ZP0}" : CZP0() : CASL() 
CASE &H07 : CYCS = CYCS + 5 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H08 : CYCS = CYCS + 3 : OPNM = "PHP {IMP}" : CIMP() : CPHP()
CASE &H09 : CYCS = CYCS + 2 : OPNM = "ORA {IMM}" : CIMM() : CORA()
CASE &H0A : CYCS = CYCS + 2 : OPNM = "ASL {IMP}" : CIMP() : CASL()
CASE &H0B : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H0C : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H0D : CYCS = CYCS + 4 : OPNM = "ORA {ABS}" : CABS() : CORA() 
CASE &H0E : CYCS = CYCS + 6 : OPNM = "ASL {ABS}" : CABS() : CASL()
CASE &H0F : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H10 : CYCS = CYCS + 2 : OPNM = "BPL {REL}" : CREL() : CBPL() 
CASE &H11 : CYCS = CYCS + 5 : OPNM = "ORA {IZY}" : CIZY() : CORA() 
CASE &H12 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H13 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H14 : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H15 : CYCS = CYCS + 4 : OPNM = "ORA {ZPX}" : CZPX() : CORA() 
CASE &H16 : CYCS = CYCS + 6 : OPNM = "ASL {ZPX}" : CZPX() : CASL() 
CASE &H17 : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H18 : CYCS = CYCS + 2 : OPNM = "CLC {IMP}" : CIMP() : CCLC()
CASE &H19 : CYCS = CYCS + 4 : OPNM = "ORA {ABY}" : CABY() : CORA() 
CASE &H1A : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H1B : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H1C : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H1D : CYCS = CYCS + 4 : OPNM = "ORA {ABX}" : CABX() : CORA()
CASE &H1E : CYCS = CYCS + 7 : OPNM = "ASL {ABX}" : CABX() : CASL() 
CASE &H1F : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H20 : CYCS = CYCS + 6 : OPNM = "JSR {ABS}" : CABS() : CJSR() 
CASE &H21 : CYCS = CYCS + 6 : OPNM = "AND {IZX}" : CIZX() : CAND() 
CASE &H22 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H23 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H24 : CYCS = CYCS + 3 : OPNM = "BIT {ZP0}" : CZP0() : CBIT() 
CASE &H25 : CYCS = CYCS + 3 : OPNM = "AND {ZP0}" : CZP0() : CAND() 
CASE &H26 : CYCS = CYCS + 5 : OPNM = "ROL {ZP0}" : CZP0() : CROL() 
CASE &H27 : CYCS = CYCS + 5 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H28 : CYCS = CYCS + 4 : OPNM = "PLP {IMP}" : CIMP() : CPLP()
CASE &H29 : CYCS = CYCS + 2 : OPNM = "AND {IMM}" : CIMM() : CAND() 
CASE &H2A : CYCS = CYCS + 2 : OPNM = "ROL {IMP}" : CIMP() : CROL()
CASE &H2B : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H2C : CYCS = CYCS + 4 : OPNM = "BIT {ABS}" : CABS() : CBIT()
CASE &H2D : CYCS = CYCS + 4 : OPNM = "AND {ABS}" : CABS() : CAND() 
CASE &H2E : CYCS = CYCS + 6 : OPNM = "ROL {ABS}" : CABS() : CROL() 
CASE &H2F : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H30 : CYCS = CYCS + 2 : OPNM = "BMI {REL}" : CREL() : CBMI() 
CASE &H31 : CYCS = CYCS + 5 : OPNM = "AND {IZY}" : CIZY() : CAND()
CASE &H32 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H33 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H34 : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H35 : CYCS = CYCS + 4 : OPNM = "AND {ZPX}" : CZPX() : CAND() 
CASE &H36 : CYCS = CYCS + 6 : OPNM = "ROL {ZPX}" : CZPX() : CROL()
CASE &H37 : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H38 : CYCS = CYCS + 2 : OPNM = "SEC {IMP}" : CIMP() : CSEC()
CASE &H39 : CYCS = CYCS + 4 : OPNM = "AND {ABY}" : CABY() : CAND() 
CASE &H3A : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H3B : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H3C : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H3D : CYCS = CYCS + 4 : OPNM = "AND {ABX}" : CABX() : CAND() 
CASE &H3E : CYCS = CYCS + 7 : OPNM = "ROL {ABX}" : CABX() : CROL() 
CASE &H3F : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H40 : CYCS = CYCS + 6 : OPNM = "RTI {IMP}" : CIMP() : CRTI()
CASE &H41 : CYCS = CYCS + 6 : OPNM = "EOR {IZX}" : CIZX() : CEOR() 
CASE &H42 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H43 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H44 : CYCS = CYCS + 3 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H45 : CYCS = CYCS + 3 : OPNM = "EOR {ZP0}" : CZP0() : CEOR()
CASE &H46 : CYCS = CYCS + 5 : OPNM = "LSR {ZP0}" : CZP0() : CLSR() 
CASE &H47 : CYCS = CYCS + 5 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H48 : CYCS = CYCS + 3 : OPNM = "PHA {IMP}" : CIMP() : CPHA()
CASE &H49 : CYCS = CYCS + 2 : OPNM = "EOR {IMM}" : CIMM() : CEOR() 
CASE &H4A : CYCS = CYCS + 2 : OPNM = "LSR {IMP}" : CIMP() : CLSR()
CASE &H4B : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H4C : CYCS = CYCS + 3 : OPNM = "JMP {ABS}" : CABS() : CJMP() 
CASE &H4D : CYCS = CYCS + 4 : OPNM = "EOR {ABS}" : CABS() : CEOR() 
CASE &H4E : CYCS = CYCS + 6 : OPNM = "LSR {ABS}" : CABS() : CLSR() 
CASE &H4F : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H50 : CYCS = CYCS + 2 : OPNM = "BVC {REL}" : CREL() : CBVC() 
CASE &H51 : CYCS = CYCS + 5 : OPNM = "EOR {IZY}" : CIZY() : CEOR() 
CASE &H52 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H53 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H54 : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H55 : CYCS = CYCS + 4 : OPNM = "EOR {ZPX}" : CZPX() : CEOR() 
CASE &H56 : CYCS = CYCS + 6 : OPNM = "LSR {ZPX}" : CZPX() : CLSR() 
CASE &H57 : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H58 : CYCS = CYCS + 2 : OPNM = "CLI {IMP}" : CIMP() : CCLI()
CASE &H59 : CYCS = CYCS + 4 : OPNM = "EOR {ABY}" : CABY() : CEOR()
CASE &H5A : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H5B : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H5C : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H5D : CYCS = CYCS + 4 : OPNM = "EOR {ABX}" : CABX() : CEOR() 
CASE &H5E : CYCS = CYCS + 7 : OPNM = "LSR {ABX}" : CABX() : CLSR()
CASE &H5F : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H60 : CYCS = CYCS + 6 : OPNM = "RTS {IMP}" : CIMP() : CRTS()
CASE &H61 : CYCS = CYCS + 6 : OPNM = "ADC {IZX}" : CIZX() : CADC() 
CASE &H62 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H63 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H64 : CYCS = CYCS + 3 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H65 : CYCS = CYCS + 3 : OPNM = "ADC {ZP0}" : CZP0() : CADC() 
CASE &H66 : CYCS = CYCS + 5 : OPNM = "ROR {ZP0}" : CZP0() : CROR() 
CASE &H67 : CYCS = CYCS + 5 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H68 : CYCS = CYCS + 4 : OPNM = "PLA {IMP}" : CIMP() : CPLA()
CASE &H69 : CYCS = CYCS + 2 : OPNM = "ADC {IMM}" : CIMM() : CADC() 
CASE &H6A : CYCS = CYCS + 2 : OPNM = "ROR {IMP}" : CIMP() : CROR()
CASE &H6B : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H6C : CYCS = CYCS + 5 : OPNM = "JMP {IND}" : CIND() : CJMP() 
CASE &H6D : CYCS = CYCS + 4 : OPNM = "ADC {ABS}" : CABS() : CADC()
CASE &H6E : CYCS = CYCS + 6 : OPNM = "ROR {ABS}" : CABS() : CROR() 
CASE &H6F : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H70 : CYCS = CYCS + 2 : OPNM = "BVS {REL}" : CREL() : CBVS() 
CASE &H71 : CYCS = CYCS + 5 : OPNM = "ADC {IZY}" : CIZY() : CADC() 
CASE &H72 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H73 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H74 : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H75 : CYCS = CYCS + 4 : OPNM = "ADC {ZPX}" : CZPX() : CADC() 
CASE &H76 : CYCS = CYCS + 6 : OPNM = "ROR {ZPX}" : CZPX() : CROR() 
CASE &H77 : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H78 : CYCS = CYCS + 2 : OPNM = "SEI {IMP}" : CIMP() : CSEI()
CASE &H79 : CYCS = CYCS + 4 : OPNM = "ADC {ABY}" : CABY() : CADC() 
CASE &H7A : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H7B : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H7C : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H7D : CYCS = CYCS + 4 : OPNM = "ADC {ABX}" : CABX() : CADC() 
CASE &H7E : CYCS = CYCS + 7 : OPNM = "ROR {ABX}" : CABX() : CROR() 
CASE &H7F : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H80 : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H81 : CYCS = CYCS + 6 : OPNM = "STA {IZX}" : CIZX() : CSTA()
CASE &H82 : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H83 : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H84 : CYCS = CYCS + 3 : OPNM = "STY {ZP0}" : CZP0() : CSTY() 
CASE &H85 : CYCS = CYCS + 3 : OPNM = "STA {ZP0}" : CZP0() : CSTA() 
CASE &H86 : CYCS = CYCS + 3 : OPNM = "STX {ZP0}" : CZP0() : CSTX()
CASE &H87 : CYCS = CYCS + 3 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H88 : CYCS = CYCS + 2 : OPNM = "DEY {IMP}" : CIMP() : CDEY()
CASE &H89 : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H8A : CYCS = CYCS + 2 : OPNM = "TXA {IMP}" : CIMP() : CTXA()
CASE &H8B : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H8C : CYCS = CYCS + 4 : OPNM = "STY {ABS}" : CABS() : CSTY() 
CASE &H8D : CYCS = CYCS + 4 : OPNM = "STA {ABS}" : CABS() : CSTA() 
CASE &H8E : CYCS = CYCS + 4 : OPNM = "STX {ABS}" : CABS() : CSTX() 
CASE &H8F : CYCS = CYCS + 4 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H90 : CYCS = CYCS + 2 : OPNM = "BCC {REL}" : CREL() : CBCC()
CASE &H91 : CYCS = CYCS + 6 : OPNM = "STA {IZY}" : CIZY() : CSTA() 
CASE &H92 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H93 : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H94 : CYCS = CYCS + 4 : OPNM = "STY {ZPX}" : CZPX() : CSTY() 
CASE &H95 : CYCS = CYCS + 4 : OPNM = "STA {ZPX}" : CZPX() : CSTA()
CASE &H96 : CYCS = CYCS + 4 : OPNM = "STX {ZPY}" : CZPY() : CSTX() 
CASE &H97 : CYCS = CYCS + 4 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H98 : CYCS = CYCS + 2 : OPNM = "TYA {IMP}" : CIMP() : CTYA()
CASE &H99 : CYCS = CYCS + 5 : OPNM = "STA {ABY}" : CABY() : CSTA() 
CASE &H9A : CYCS = CYCS + 2 : OPNM = "TXS {IMP}" : CIMP() : CTXS()
CASE &H9B : CYCS = CYCS + 5 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H9C : CYCS = CYCS + 5 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &H9D : CYCS = CYCS + 5 : OPNM = "STA {ABX}" : CABX() : CSTA() 
CASE &H9E : CYCS = CYCS + 5 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &H9F : CYCS = CYCS + 5 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HA0 : CYCS = CYCS + 2 : OPNM = "LDY {IMM}" : CIMM() : CLDY() 
CASE &HA1 : CYCS = CYCS + 6 : OPNM = "LDA {IZX}" : CIZX() : CLDA() 
CASE &HA2 : CYCS = CYCS + 2 : OPNM = "LDX {IMM}" : CIMM() : CLDX() 
CASE &HA3 : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HA4 : CYCS = CYCS + 3 : OPNM = "LDY {ZP0}" : CZP0() : CLDY()
CASE &HA5 : CYCS = CYCS + 3 : OPNM = "LDA {ZP0}" : CZP0() : CLDA() 
CASE &HA6 : CYCS = CYCS + 3 : OPNM = "LDX {ZP0}" : CZP0() : CLDX() 
CASE &HA7 : CYCS = CYCS + 3 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HA8 : CYCS = CYCS + 2 : OPNM = "TAY {IMP}" : CIMP() : CTAY()
CASE &HA9 : CYCS = CYCS + 2 : OPNM = "LDA {IMM}" : CIMM() : CLDA()
CASE &HAA : CYCS = CYCS + 2 : OPNM = "TAX {IMP}" : CIMP() : CTAX()
CASE &HAB : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HAC : CYCS = CYCS + 4 : OPNM = "LDY {ABS}" : CABS() : CLDY() 
CASE &HAD : CYCS = CYCS + 4 : OPNM = "LDA {ABS}" : CABS() : CLDA() 
CASE &HAE : CYCS = CYCS + 4 : OPNM = "LDX {ABS}" : CABS() : CLDX()
CASE &HAF : CYCS = CYCS + 4 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HB0 : CYCS = CYCS + 2 : OPNM = "BCS {REL}" : CREL() : CBCS() 
CASE &HB1 : CYCS = CYCS + 5 : OPNM = "LDA {IZY}" : CIZY() : CLDA() 
CASE &HB2 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HB3 : CYCS = CYCS + 5 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HB4 : CYCS = CYCS + 4 : OPNM = "LDY {ZPX}" : CZPX() : CLDY() 
CASE &HB5 : CYCS = CYCS + 4 : OPNM = "LDA {ZPX}" : CZPX() : CLDA() 
CASE &HB6 : CYCS = CYCS + 4 : OPNM = "LDX {ZPY}" : CZPY() : CLDX() 
CASE &HB7 : CYCS = CYCS + 4 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HB8 : CYCS = CYCS + 2 : OPNM = "CLV {IMP}" : CIMP() : CCLV()
CASE &HB9 : CYCS = CYCS + 4 : OPNM = "LDA {ABY}" : CABY() : CLDA() 
CASE &HBA : CYCS = CYCS + 2 : OPNM = "TSX {IMP}" : CIMP() : CTSX()
CASE &HBB : CYCS = CYCS + 4 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HBC : CYCS = CYCS + 4 : OPNM = "LDY {ABX}" : CABX() : CLDY() 
CASE &HBD : CYCS = CYCS + 4 : OPNM = "LDA {ABX}" : CABX() : CLDA()
CASE &HBE : CYCS = CYCS + 4 : OPNM = "LDX {ABY}" : CABY() : CLDX() 
CASE &HBF : CYCS = CYCS + 4 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HC0 : CYCS = CYCS + 2 : OPNM = "CPY {IMM}" : CIMM() : CCPY() 
CASE &HC1 : CYCS = CYCS + 6 : OPNM = "CMP {IZX}" : CIZX() : CCMP() 
CASE &HC2 : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &HC3 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HC4 : CYCS = CYCS + 3 : OPNM = "CPY {ZP0}" : CZP0() : CCPY() 
CASE &HC5 : CYCS = CYCS + 3 : OPNM = "CMP {ZP0}" : CZP0() : CCMP() 
CASE &HC6 : CYCS = CYCS + 5 : OPNM = "DEC {ZP0}" : CZP0() : CDEC() 
CASE &HC7 : CYCS = CYCS + 5 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HC8 : CYCS = CYCS + 2 : OPNM = "INY {IMP}" : CIMP() : CINY()
CASE &HC9 : CYCS = CYCS + 2 : OPNM = "CMP {IMM}" : CIMM() : CCMP() 
CASE &HCA : CYCS = CYCS + 2 : OPNM = "DEX {IMP}" : CIMP() : CDEX()
CASE &HCB : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HCC : CYCS = CYCS + 4 : OPNM = "CPY {ABS}" : CABS() : CCPY()
CASE &HCD : CYCS = CYCS + 4 : OPNM = "CMP {ABS}" : CABS() : CCMP() 
CASE &HCE : CYCS = CYCS + 6 : OPNM = "DEC {ABS}" : CABS() : CDEC() 
CASE &HCF : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HD0 : CYCS = CYCS + 2 : OPNM = "BNE {REL}" : CREL() : CBNE() 
CASE &HD1 : CYCS = CYCS + 5 : OPNM = "CMP {IZY}" : CIZY() : CCMP()
CASE &HD2 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HD3 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HD4 : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &HD5 : CYCS = CYCS + 4 : OPNM = "CMP {ZPX}" : CZPX() : CCMP() 
CASE &HD6 : CYCS = CYCS + 6 : OPNM = "DEC {ZPX}" : CZPX() : CDEC()
CASE &HD7 : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HD8 : CYCS = CYCS + 2 : OPNM = "CLD {IMP}" : CIMP() : CCLD()
CASE &HD9 : CYCS = CYCS + 4 : OPNM = "CMP {ABY}" : CABY() : CCMP() 
CASE &HDA : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &HDB : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HDC : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &HDD : CYCS = CYCS + 4 : OPNM = "CMP {ABX}" : CABX() : CCMP() 
CASE &HDE : CYCS = CYCS + 7 : OPNM = "DEC {ABX}" : CABX() : CDEC() 
CASE &HDF : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HE0 : CYCS = CYCS + 2 : OPNM = "CPX {IMM}" : CIMM() : CCPX()
CASE &HE1 : CYCS = CYCS + 6 : OPNM = "SBC {IZX}" : CIZX() : CSBC() 
CASE &HE2 : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &HE3 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HE4 : CYCS = CYCS + 3 : OPNM = "CPX {ZP0}" : CZP0() : CCPX() 
CASE &HE5 : CYCS = CYCS + 3 : OPNM = "SBC {ZP0}" : CZP0() : CSBC()
CASE &HE6 : CYCS = CYCS + 5 : OPNM = "INC {ZP0}" : CZP0() : CINC() 
CASE &HE7 : CYCS = CYCS + 5 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HE8 : CYCS = CYCS + 2 : OPNM = "INX {IMP}" : CIMP() : CINX()
CASE &HE9 : CYCS = CYCS + 2 : OPNM = "SBC {IMM}" : CIMM() : CSBC() 
CASE &HEA : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &HEB : CYCS = CYCS + 2 : OPNM = "SBC {IMP}" : CIMP() : CSBC()
CASE &HEC : CYCS = CYCS + 4 : OPNM = "CPX {ABS}" : CABS() : CCPX() 
CASE &HED : CYCS = CYCS + 4 : OPNM = "SBC {ABS}" : CABS() : CSBC() 
CASE &HEE : CYCS = CYCS + 6 : OPNM = "INC {ABS}" : CABS() : CINC() 
CASE &HEF : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HF0 : CYCS = CYCS + 2 : OPNM = "BEQ {REL}" : CREL() : CBEQ() 
CASE &HF1 : CYCS = CYCS + 5 : OPNM = "SBC {IZY}" : CIZY() : CSBC()
CASE &HF2 : CYCS = CYCS + 2 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HF3 : CYCS = CYCS + 8 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HF4 : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &HF5 : CYCS = CYCS + 4 : OPNM = "SBC {ZPX}" : CZPX() : CSBC()
CASE &HF6 : CYCS = CYCS + 6 : OPNM = "INC {ZPX}" : CZPX() : CINC()
CASE &HF7 : CYCS = CYCS + 6 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HF8 : CYCS = CYCS + 2 : OPNM = "SED {IMP}" : CIMP() : CSED()
CASE &HF9 : CYCS = CYCS + 4 : OPNM = "SBC {ABY}" : CABY() : CSBC()
CASE &HFA : CYCS = CYCS + 2 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &HFB : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
CASE &HFC : CYCS = CYCS + 4 : OPNM = "NOP {IMP}" : CIMP() : CNOP()
CASE &HFD : CYCS = CYCS + 4 : OPNM = "SBC {ABX}" : CABX() : CSBC()
CASE &HFE : CYCS = CYCS + 7 : OPNM = "INC {ABX}" : CABX() : CINC()
CASE &HFF : CYCS = CYCS + 7 : OPNM = "XXX {IMP}" : CIMP() : CXXX()
END SELECT
END SUB

SUB CBRK()
PC = (PC + 1) AND &HFFFF
CPUW(&H0100 + STKP, ((PC >> 8) AND &H00FF))
STKP = (STKP - 1) AND &HFF
CPUW(&H0100 + STKP, (PC AND &H00FF))
STKP = (STKP - 1) AND &HFF
SETFLG(BFLG, 1)
CPUW((&H0100 + STKP), STAT)
STKP = (STKP - 1) AND &HFF
SETFLG(IFLG, 1)
SETFLG(BFLG, 0)
PC = (BUSR(&HFFFE) OR ((BUSR(&HFFFF) << 8))) AND &HFFFF
AC1 = 0
END SUB

SUB CADC()
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
TEMP = ((AREG + FETD) + GETFLG(CFLG))
SETFLG(CFLG, (TEMP > 255))
SETFLG(ZFLG, ((TEMP AND &H00FF) = 0))
SETFLG(VFLG, ((INV(AREG XOR FETD) AND (AREG XOR TEMP) AND &H0080) > 0))
SETFLG(NFLG, ((TEMP AND &H80) = 128))
AREG = (TEMP AND &H00FF)
AC1 = 1
END SUB

SUB CSBC()
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
LOCAL INTEGER VALUE = ((FETD) XOR &H00FF)
TEMP = ((AREG + VALUE) + GETFLG(CFLG))
SETFLG(CFLG, (TEMP > 255))
SETFLG(ZFLG, ((TEMP AND &H00FF) = 0))
SETFLG(VFLG, (((TEMP XOR AREG) AND (TEMP XOR VALUE) AND &H0080) > 0))
SETFLG(NFLG, ((TEMP AND &H80) = 128))
AREG = (TEMP AND &H00FF)
AC1 = 1
END SUB

SUB CASL() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
TEMP = (FETD << 1) AND &HFFFF
SETFLG(CFLG, ((TEMP AND &HFF00) > 0))
SETFLG(ZFLG, ((TEMP AND &H00FF) = &H00))
SETFLG(NFLG, ((TEMP AND &H80) <> 0))
IF (RIGHT$(OPNM$, 5) = "{IMP}") THEN 'TEMP FOR NOW
AREG = TEMP AND &H00FF
ELSE 
CPUW(AABS, (TEMP AND &H00FF))
END IF
AC1 = 0
END SUB

SUB CAND() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
AREG = (AREG AND FETD) AND &HFF
SETFLG(ZFLG, (AREG = &H00))
SETFLG(NFLG, ((AREG AND &H80) <> 0))
AC1 = 1 
END SUB

SUB CBCC() 
IF (GETFLG(CFLG) = 0) THEN
CYCS = CYCS + 1
AABS = (PC + AREL) AND &HFFFF
IF ((AABS AND &HFF00) <> (PC AND &HFF00)) THEN
CYCS = CYCS + 1
END IF
PC = AABS
END IF
AC1 = 0
END SUB

SUB CBCS() 
IF (GETFLG(CFLG) ) THEN
CYCS = CYCS + 1
AABS = (PC + AREL) AND &HFFFF
IF ((AABS AND &HFF00) <> (PC AND &HFF00)) THEN
CYCS = CYCS + 1
END IF
PC = AABS
END IF
AC1 = 0
END SUB

SUB CBEQ() 
IF (GETFLG(ZFLG) ) THEN
CYCS = CYCS + 1
AABS = (PC + AREL) AND &HFFFF
IF ((AABS AND &HFF00) <> (PC AND &HFF00)) THEN
CYCS = CYCS + 1
END IF

PC = AABS
END IF
AC1 = 0
END SUB

SUB CBIT() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
TEMP = (AREG AND FETD) AND&HFF
SETFLG(ZFLG, ((TEMP AND &H00FF) = &H00))
SETFLG(NFLG, ((FETD AND (128)) <> 0))
SETFLG(VFLG, ((FETD AND (64)) <> 0))
AC1 = 0
END SUB

SUB CBMI() 
IF (GETFLG(NFLG) ) THEN
CYCS = CYCS + 1
AABS = (PC + AREL) AND &HFFFF
IF ((AABS AND &HFF00) <> (PC AND &HFF00)) THEN
CYCS = CYCS + 1
END IF
PC = AABS
END IF
AC1 = 0
END SUB

SUB CBNE() 
IF (GETFLG(ZFLG) = 0) THEN
CYCS = CYCS + 1
AABS = (PC + AREL) AND &HFFFF
IF ((AABS AND &HFF00) <> (PC AND &HFF00)) THEN
CYCS = CYCS + 1
END IF
PC = AABS
END IF
AC1 = 0
END SUB

SUB CBPL() 
IF (GETFLG(NFLG) = 0) THEN
CYCS = CYCS + 1
AABS = (PC + AREL) AND &HFFFF
IF ((AABS AND &HFF00) <> (PC AND &HFF00)) THEN
CYCS = CYCS + 1
END IF
PC = AABS
END IF
AC1 = 0
END SUB

SUB CBVC() 
IF (GETFLG(VFLG) = 0) THEN 
CYCS = CYCS + 1
AABS = (PC + AREL) AND &HFFFF
IF ((AABS AND &HFF00) <> (PC AND &HFF00)) THEN
CYCS = CYCS + 1
END IF 
PC = AABS
END IF
AC1 = 0
END SUB

SUB CBVS() 
IF (GETFLG(VFLG) ) THEN
CYCS = CYCS + 1
AABS = (PC + AREL) AND &HFFFF
IF ((AABS AND &HFF00) <> (PC AND &HFF00)) THEN
CYCS = CYCS + 1
END IF
PC = AABS
END IF
AC1 = 0
END SUB

SUB CCLC() 
SETFLG(CFLG, 0)
AC1 = 0
END SUB

SUB CCLD() 
SETFLG(DFLG, 0)
AC1 = 0
END SUB

SUB CCLI() 
SETFLG(IFLG, 0)
AC1 = 0
END SUB

SUB CCLV() 
SETFLG(VFLG, 0)
AC1 = 0
END SUB

SUB CCMP() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
TEMP = (AREG - FETD) AND &HFFFF
SETFLG(CFLG, (AREG >= FETD))
SETFLG(ZFLG, ((TEMP AND &H00FF) = &H0000))
SETFLG(NFLG, ((TEMP AND &H0080) <> 0))
AC1 = 1 
END SUB

SUB CCPX() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
TEMP = (XREG - FETD) AND &HFFFF
SETFLG(CFLG, (XREG >= FETD))
SETFLG(ZFLG, ((TEMP AND &H00FF) = &H0000))
SETFLG(NFLG, ((TEMP AND &H0080) <> 0))
AC1 = 0
END SUB

SUB CCPY() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
TEMP = (YREG - FETD) AND &HFFFF
SETFLG(CFLG, (YREG >= FETD))
SETFLG(ZFLG, ((TEMP AND &H00FF) = &H0000))
SETFLG(NFLG, ((TEMP AND &H0080) <> 0))
AC1 = 0
END SUB

SUB CDEC() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
TEMP = (FETD - 1) AND &HFFFF
CPUW(AABS, (TEMP AND &H00FF))
SETFLG(ZFLG, (TEMP AND &H00FF) = &H0000))
SETFLG(NFLG, ((TEMP AND &H0080) <> 0))
AC1 = 0
END SUB

SUB CDEX() 
XREG = (XREG - 1) AND &HFF
SETFLG(ZFLG, (XREG = &H00))
SETFLG(NFLG, ((XREG AND &H80) <> 0))
AC1 = 0
END SUB

SUB CDEY() 
YREG = (YREG - 1) AND &HFF
SETFLG(ZFLG, (YREG = &H00))
SETFLG(NFLG, ((YREG AND &H0080) <> 0))
AC1 = 0
END SUB

SUB CEOR() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
LOCAL INTEGER TEMPA = AREG XOR FETD AND &HFF
AREG = TEMPA AND &HFF
SETFLG(ZFLG, (AREG = &H00))
SETFLG(NFLG, ((AREG AND &H0080) <> 0))
AC1 = 1 
END SUB

SUB CINC() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
TEMP = (FETD + 1) AND &HFFFF
CPUW(AABS, (TEMP AND &H00FF))
SETFLG(ZFLG, ((TEMP AND &H00FF) = &H0000))
SETFLG(NFLG, ((TEMP AND &H0080) <> 0))
AC1 = 0
END SUB

SUB CIND() 
LOCAL INTEGER PTR_LO = BUSR(PC)
PC = (PC + 1) AND &HFFFF
LOCAL INTEGER PTR_HI = BUSR(PC)
PC = (PC + 1) AND &HFFFF
LOCAL INTEGER PTR = ((PTR_HI << 8) OR PTR_LO)
IF (PTR_LO = &H00FF) THEN
AABS = ((BUSR((PTR AND &HFF00) << 8)) OR (BUSR(PTR + 0)))
ELSE 
AABS = ((BUSR((PTR + 1) << 8)) OR (BUSR(PTR + 0)))
END IF
AC1 = 0
END SUB

SUB CINX() 
XREG = (XREG + 1) AND &HFF
SETFLG(ZFLG, (XREG = &H00))
SETFLG(NFLG, ((XREG AND &H80) <> 0))
AC1 = 0
END SUB

SUB CINY() 
YREG = (YREG + 1) AND &HFF
SETFLG(ZFLG, (YREG = &H00))
SETFLG(NFLG, ((YREG AND &H80) <> 0))
AC1 = 0
END SUB

SUB CJMP() 
PC = AABS
AC1 = 0
END SUB

SUB CJSR() 
PC = (PC - 1) AND &HFFFF
CPUW((&H0100 + STKP), ((PC >> 8) AND &H00FF))
STKP = (STKP - 1) AND &HFF
CPUW((&H0100 + STKP), (PC AND &H00FF))
STKP = (STKP - 1) AND &HFF
PC = AABS
AC1 = 0
END SUB

SUB CLDA() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
AREG = FETD AND &HFF
SETFLG(ZFLG, (AREG = 0))
SETFLG(NFLG, ((AREG AND &H80) <> 0))
AC1 = 1 
END SUB

SUB CLDX() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
XREG = FETD AND &HFF
SETFLG(ZFLG, (XREG = &H00))
SETFLG(NFLG, ((XREG AND &H80) <> 0))
AC1 = 1 
END SUB

SUB CLDY() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
YREG = FETD AND &HFF
SETFLG(ZFLG, (YREG = &H00))
SETFLG(NFLG, ((YREG AND &H80) <> 0))
AC1 = 1 
END SUB

SUB CLSR() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
SETFLG(CFLG, ((FETD AND &H0001) <> 0))
TEMP = (FETD >> 1)
SETFLG(ZFLG, ((TEMP AND &H00FF) = &H0000))
SETFLG(NFLG, ((TEMP AND &H0080) <> 0))
IF (RIGHT$(OPNM$, 5) = "{IMP}") THEN 'TEMP FOR NOW
AREG = TEMP AND &H00FF
ELSE 
CPUW(AABS, (TEMP AND &H00FF))
END IF
END SUB


SUB CNOP() 
SELECT CASE (OP) 
CASE &H1C : AC1 = 0 
CASE &H3C : AC1 = 0 
CASE &H5C : AC1 = 0 
CASE &H7C : AC1 = 0 
CASE &HDC : AC1 = 0 
CASE &HFC : AC1 = 1
END SELECT
END SUB

SUB CORA() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
AREG = (AREG OR FETD) AND &HFF
SETFLG(ZFLG, AREG = &H00)
SETFLG(NFLG, ((AREG AND &H80) <> 0))
AC1 = 1 
END SUB

SUB CPHA() 
CPUW((&H0100 + STKP), AREG)
STKP = (STKP - 1) AND &HFF
AC1 = 0
END SUB

SUB CPHP() 
CPUW((&H0100 + STKP), ((STAT OR BFLG) OR UFLG))
SETFLG(BFLG, 0)
SETFLG(UFLG, 0)
STKP = (STKP - 1) AND &HFF
AC1 = 0
END SUB

SUB CPLA() 
STKP = (STKP + 1) AND &HFF
AREG = BUSR(&H0100 + STKP)
SETFLG(ZFLG, (AREG = &H00))
SETFLG(NFLG, ((AREG AND &H80) <> 0))
AC1 = 0
END SUB

SUB CPLP() 
STKP = (STKP + 1) AND &HFF
STAT = BUSR(&H0100 + STKP) AND &HFF
SETFLG(UFLG, 1)
AC1 = 0
END SUB

SUB CROL() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
TEMP = (FETD << 1) OR GETFLG(CFLG)
SETFLG(CFLG, ((TEMP AND &HFF00) <> 0))
SETFLG(ZFLG, ((TEMP AND &H00FF) = &H0000))
SETFLG(NFLG, ((TEMP AND &H0080) <> 0))
IF (RIGHT$(OPNM$, 5) = "{IMP}") THEN 'TEMP FOR NOW
AREG = TEMP AND &H00FF
ELSE 
CPUW(AABS, (TEMP AND &H00FF))
END IF
AC1 = 0
END SUB

SUB CROR() 
IF ((RIGHT$(OPNM$, 5)) <> "{IMP}") THEN 'TEMP FOR NOW
FETD = BUSR(AABS)
END IF
TEMP = ((GETFLG(CFLG) << 7) OR (FETD >> 1))
SETFLG(CFLG, ((FETD AND &H01) <> 0))
SETFLG(ZFLG, ((TEMP AND &H00FF) = &H00))
SETFLG(NFLG, ((TEMP AND &H0080) <> 0))
IF (RIGHT$(OPNM$, 5) = "{IMP}") THEN 'TEMP FOR NOW
AREG = TEMP AND &H00FF
ELSE 
CPUW(AABS, (TEMP AND &H00FF))
END IF 
AC1 = 0
END SUB

SUB CRTI() 
STKP = (STKP + 1) AND &HFF
STAT = BUSR(&H0100 + STKP) AND &HFF
STAT = (STAT AND (INV BFLG)) AND &HFF 
STAT = (STAT AND (INV UFLG)) AND &HFF 
STKP = (STKP + 1) AND &HFF
PC = BUSR(&H0100 + STKP) AND &HFFFF
STKP = (STKP + 1) AND &HFF
LOCAL INTEGER TPC1
LOCAL INTEGER TPC2
TPC1 = BUSR(STKP + 256) 
TPC2 = (TPC1 << 8) AND &HFFFF
TPC1 = (PC OR TPC2) AND &HFFFF
PC = TPC1
AC1 = 0
END SUB

SUB CRTS() 
STKP = (STKP + 1) AND &HFF
PC = BUSR(&H0100 + STKP) AND &HFFFF
STKP = (STKP + 1) AND &HFF
PC = ((PC OR (BUSR(&H0100 + STKP) << 8 ))) AND &HFFFF
PC = (PC + 1) AND &HFFFF
AC1 = 0
END SUB

SUB CSEC() 
SETFLG(CFLG, 1) 
AC1 = 0
END SUB

SUB CSED() 
SETFLG(DFLG, 1)
AC1 = 0
END SUB

SUB CSEI() 
SETFLG(IFLG, 1)
AC1 = 0
END SUB

SUB CSTA() 
CPUW(AABS, AREG)
AC1 = 0
END SUB

SUB CSTX() 
CPUW(AABS, XREG)
AC1 = 0
END SUB

SUB CSTY() 
CPUW(AABS, YREG)
AC1 = 0
END SUB

SUB CTAX() 
XREG = AREG
SETFLG(ZFLG, (XREG = &H00))
SETFLG(NFLG, ((XREG AND &H80) <> 0))
AC1 = 0
END SUB

SUB CTAY() 
YREG = AREG
SETFLG(ZFLG, (YREG = &H00))
SETFLG(NFLG, ((YREG AND &H80) <> 0))
AC1 = 0
END SUB

SUB CTSX() 
XREG = STKP AND &HFF
SETFLG(ZFLG, (XREG = &H00))
SETFLG(NFLG, ((XREG AND &H80) <> 0))
AC1 = 0
END SUB

SUB CTXA() 
AREG = XREG
SETFLG(ZFLG, (AREG = &H00))
SETFLG(NFLG, ((AREG AND &H80) <> 0))
AC1 = 0
END SUB

SUB CTXS() 
STKP = XREG
AC1 = 0
END SUB

SUB CTYA() 
AREG = YREG
SETFLG(ZFLG, (AREG = &H00))
SETFLG(NFLG, (AREG AND &H80) <> 0)
AC1 = 0
END SUB

SUB CXXX()
AC1 = 0 
END SUB

SUB CZPY() 
AABS = (BUSR(PC) + YREG) AND &HFFFF
PC = (PC + 1) AND &HFFFF
AABS = AABS AND &H00FF
AC1 = 0
END SUB

' OP2
SUB CABS() 
LOCAL INTEGER TLO = BUSR(PC)
PC = (PC + 1) AND &HFFFF
LOCAL INTEGER THI = BUSR(PC)
PC = (PC + 1) AND &HFFFF
AABS = ((THI << 8) OR TLO) AND &HFFFF
AC2 = 0
END SUB

SUB CABX() 
LOCAL INTEGER TLO = BUSR(PC)
PC = (PC + 1) AND &HFFFF
LOCAL INTEGER THI = BUSR(PC)
PC = (PC + 1) AND &HFFFF
AABS = ((THI << 8) OR TLO) AND &HFFFF
AABS = (AABS + XREG) AND &HFFFF
IF ((AABS AND &HFF00) <> (THI << 8)) THEN
AC2 = 1 
ELSE
AC2 = 0
END IF
END SUB

SUB CABY() 
LOCAL INTEGER TLO = BUSR(PC)
PC = (PC + 1) AND &HFFFF
LOCAL INTEGER THI = BUSR(PC)
PC = (PC + 1) AND &HFFFF
AABS = ((THI << 8) OR TLO) AND &HFFFF
AABS = (AABS + YREG) AND &HFFFF
IF ((AABS AND &HFF00) <> (THI << 8)) THEN
AC2 = 1 
ELSE
AC2 = 0
END IF
END SUB

SUB CIMM()
AABS = PC AND &HFFFF
PC = (PC + 1) AND &HFFFF
AC2 = 0
END SUB

SUB CIMP() 
FETD = AREG
AC2 = 0
END SUB

SUB CIZX() 
LOCAL INTEGER TEMP = BUSR(PC)
PC = (PC + 1) AND &HFFFF
LOCAL INTEGER TLO = BUSR(TEMP + XREG) AND &H00FF
LOCAL INTEGER THI = BUSR((TEMP + XREG) + 1) AND &H00FF
AABS = ((THI << 8) OR TLO) AND &HFFFF 
AC2 = 0
END SUB

SUB CIZY() 
LOCAL INTEGER TEMP = BUSR(PC)
PC = (PC + 1) AND &HFFFF
LOCAL INTEGER TLO = BUSR(TEMP) AND &H00FF
LOCAL INTEGER THI = BUSR(TEMP + 1) AND &H00FF
AABS = ((THI << 8) OR TLO) AND &HFFFF
AABS = (AABS + YREG) AND &HFFFF
IF (((AABS) AND &HFF00) <> (THI << 8)) THEN
AC2 = 1
ELSE
AC2 = 0
END IF
END SUB

SUB CREL() 
AREL = BUSR(PC)
PC = (PC + 1) AND &HFFFF
IF (AREL AND &H80) <> 0) THEN
LOCAL INTEGER TEMPAREL
TEMPAREL = (AREL OR &HFF00)
AREL = TEMPAREL
END IF
AC2 = 0
END SUB

SUB CZP0() 
AABS = BUSR(PC) AND &HFFFF
PC = (PC + 1) AND &HFFFF
local integer tempabs
AABS = AABS AND &H00FF
AC2 = 0
END SUB

SUB CZPX() 
AABS = (BUSR(PC) + XREG) AND &HFFFF
PC = (PC + 1) AND &HFFFF
AABS = AABS AND &H00FF
AC2 = 0
END SUB
